<template>
    <base-detail-page :title="$t('profile.title')">
        <text-status :status="block ? 'warning' : 'questionnaire'">
            {{block ? $t('profile.block') : ''}}
        </text-status>

        <form
            :class="[
                'profile base-detail-page__default-margin',
                 {
                     'form-block--send': statusForm
                 }
             ]"
            data-vv-scope="profile-form-scope"
            autocomplete="off"
        >
            <base-container size="mini">
                <div class="verify-form__separator">
                    <h2>{{ $t('profile.personal-data.title') }}</h2>

                    <div class="input-kit default-margin-input">
                        <input
                            type="text"
                            id="profile_surname"
                            v-model.lazy="profile.surname"
                            :placeholder="$t('profile.personal-data.surname')"
                            name="SURNAME"
                            ref="SURNAME"
                            data-vv-validate-on="blur"
                            class="input main"
                            v-validate="'required|min:2'"
                            maxlength="50"
                            @focus="setFocusElement"
                            @blur="clearFocusElement"
                        >
                        <transition name="slide">
                            <div
                                v-show="errors.has('profile-form-scope.SURNAME') &&
                                profile.surname !== '' &&
                                focusElement !== 'SURNAME'"
                            >
                                <div class="error-message input-kit__error-message">
                                    {{ errors.first('SURNAME', 'profile-form-scope') }}
                                </div>
                            </div>
                        </transition>
                    </div>

                    <div class="input-kit default-margin-input">
                        <input
                            type="text"
                            id="profile_name"
                            v-model.lazy="profile.name"
                            :placeholder="$t('profile.personal-data.name')"
                            name="NAME"
                            ref="NAME"
                            data-vv-validate-on="blur"
                            class="input main"
                            v-validate="'required|min:2'"
                            maxlength="50"
                            @focus="setFocusElement"
                            @blur="clearFocusElement"
                        >
                        <transition name="slide">
                            <div
                                v-show="errors.has('profile-form-scope.NAME') &&
                                profile.name !== '' &&
                                focusElement !== 'NAME'"
                            >
                                <div class="error-message input-kit__error-message">
                                    {{ errors.first('NAME', 'profile-form-scope') }}
                                </div>
                            </div>
                        </transition>
                    </div>

                    <div class="input-kit default-margin-input">
                        <input
                            type="text"
                            id="profile_patronymic"
                            v-model.lazy="profile.patronymic"
                            :placeholder="$t('profile.personal-data.patronymic')"
                            name="PATRONYMIC"
                            ref="PATRONYMIC"
                            data-vv-validate-on="blur"
                            class="input main"
                            v-validate="'required|min:2'"
                            maxlength="50"
                            @focus="setFocusElement"
                            @blur="clearFocusElement"
                        >
                        <transition name="slide">
                            <div
                                v-show="errors.has('profile-form-scope.PATRONYMIC') &&
                                profile.patronymic !== '' &&
                                focusElement !== 'PATRONYMIC'"
                            >
                                <div class="error-message input-kit__error-message">
                                    {{ errors.first('PATRONYMIC', 'profile-form-scope') }}
                                </div>
                            </div>
                        </transition>
                    </div>

                    <div class="input-kit default-margin-input">
                        <input
                            type="text"
                            id="profile_birthday"
                            v-model="profile.birthday"
                            :placeholder="$t('profile.personal-data.b_day')"
                            name="BIRTHDAY"
                            ref="BIRTHDAY"
                            data-vv-validate-on="blur"
                            class="input main"
                            v-validate="'required|date_format:dd.MM.yyyy|bDay'"
                            v-mask="'##.##.####'"
                            @focus="setFocusElement"
                            @blur="clearFocusElement"
                        >
                        <transition name="slide">
                            <div
                                v-show="errors.has('profile-form-scope.BIRTHDAY') &&
                                profile.birthday !== '' &&
                                focusElement !== 'BIRTHDAY'"
                            >
                                <div class="error-message input-kit__error-message">
                                    {{ errors.first('BIRTHDAY', 'profile-form-scope') }}
                                </div>
                            </div>
                        </transition>
                    </div>

                    <div class="input-kit default-margin-input">
                        <input
                            type="text"
                            id="profile_phone"
                            v-model="profile.phone"
                            :placeholder="$t('profile.personal-data.phone')"
                            name="PHONE"
                            ref="PHONE"
                            data-vv-validate-on="blur"
                            class="input main"
                            v-validate="'required'"
                            v-mask="'+7##########'"
                            @focus="setFocusElement"
                            @blur="clearFocusElement"
                        >
                        <transition name="slide">
                            <div
                                v-show="errors.has('profile-form-scope.PHONE') &&
                                profile.phone !== '' &&
                                focusElement !== 'PHONE'"
                            >
                                <div class="error-message input-kit__error-message">
                                    {{ errors.first('PHONE', 'profile-form-scope') }}
                                </div>
                            </div>
                        </transition>
                    </div>
                </div>

                <div class="verify-form__separator">

                    <h2>{{ $t('profile.passport-data.title') }}</h2>

                    <div class="input-kit default-margin-input">
                        <input
                            type="text"
                            v-model="profile.passport_num"
                            id="profile_passport_num"
                            :placeholder="$t('profile.passport-data.series')"
                            name="PASSPORT_SERIES"
                            ref="PASSPORT_SERIES"
                            class="input main"
                            data-vv-validate-on="blur"
                            v-mask="'####-######'"
                            v-validate="'required|seriesPassport'"
                            @focus="setFocusElement"
                            @blur="clearFocusElement"
                        >
                        <transition name="slide">
                            <div
                                v-show="errors.has('profile-form-scope.PASSPORT_SERIES') &&
                                profile.passport_num !== '' &&
                                focusElement !== 'PASSPORT_SERIES'"
                            >
                                <div class="error-message input-kit__error-message">
                                    {{ errors.first('PASSPORT_SERIES', 'profile-form-scope') }}
                                </div>
                            </div>
                        </transition>
                    </div>

                    <div class="input-kit default-margin-input">
                        <input
                            type="text"
                            id="profile_passport_date"
                            v-model="profile.passport_date"
                            :placeholder="$t('profile.passport-data.date')"
                            name="PASSPORT_DATE"
                            ref="PASSPORT_DATE"
                            class="input main"
                            v-validate="'required|date_format:dd.MM.yyyy|datePassport'"
                            data-vv-validate-on="blur"
                            v-mask="'##.##.####'"
                            @focus="setFocusElement"
                            @blur="clearFocusElement"
                        >
                        <transition name="slide">
                            <div
                                v-show="errors.has('profile-form-scope.PASSPORT_DATE') &&
                                profile.passport_date !== '' &&
                                focusElement !== 'PASSPORT_DATE'"
                            >
                                <div class="error-message input-kit__error-message">
                                    {{ errors.first('PASSPORT_DATE', 'profile-form-scope') }}
                                </div>
                            </div>
                        </transition>
                    </div>

                    <div class="input-kit default-margin-input">
                        <input
                            type="text"
                            id="profile_passport_issued_by"
                            v-model="profile.passport_issued_by"
                            :placeholder="$t('profile.passport-data.issue')"
                            name="PASSPORT_ISSUED_BY"
                            ref="PASSPORT_ISSUED_BY"
                            class="input main"
                            v-validate="'required'"
                            data-vv-validate-on="blur"
                            maxlength="100"
                            @focus="setFocusElement"
                            @blur="clearFocusElement"
                        >
                        <transition name="slide">
                            <div
                                v-show="errors.has('profile-form-scope.PASSPORT_ISSUED_BY') &&
                                profile.passport_issued_by !== '' &&
                                focusElement !== 'PASSPORT_ISSUED_BY'"
                            >
                                <div class="error-message input-kit__error-message">
                                    {{ errors.first('PASSPORT_ISSUED_BY', 'profile-form-scope') }}
                                </div>
                            </div>
                        </transition>
                    </div>


                    <div class="input-kit default-margin-input">
                        <input
                            type="text"
                            id="profile_passport_department"
                            v-model="profile.passport_department"
                            :placeholder="$t('profile.passport-data.code')"
                            name="PASSPORT_DIVISION"
                            ref="PASSPORT_DIVISION"
                            class="input main"
                            v-validate="'required|codePassport'"
                            v-mask="'###-###'"
                            data-vv-validate-on="blur"
                            maxlength="7"
                            @focus="setFocusElement"
                            @blur="clearFocusElement"
                        >
                        <transition name="slide">
                            <div
                                v-show="errors.has('profile-form-scope.PASSPORT_DIVISION') &&
                                profile.passport_department !== '' &&
                                focusElement !== 'PASSPORT_DIVISION'"
                            >
                                <div class="error-message input-kit__error-message">
                                    {{ errors.first('PASSPORT_DIVISION', 'profile-form-scope') }}
                                </div>
                            </div>
                        </transition>
                    </div>


                    <div class="input-kit default-margin-input">
                        <input
                            type="text"
                            id="profile_address"
                            v-model="profile.address"
                            :placeholder="$t('profile.passport-data.address')"
                            name="ADDRESS"
                            ref="ADDRESS"
                            class="input main"
                            v-validate="'required|min:2'"
                            data-vv-validate-on="blur"
                            @focus="setFocusElement"
                            @blur="clearFocusElement"
                        >
                        <transition name="slide">
                            <div
                                v-show="errors.has('profile-form-scope.ADDRESS') &&
                                profile.address !== '' &&
                                focusElement !== 'ADDRESS'"
                            >
                                <div class="error-message input-kit__error-message">
                                    {{ errors.first('ADDRESS', 'profile-form-scope') }}
                                </div>
                            </div>
                        </transition>
                    </div>

                    <h3>{{ $t('profile.scan.title') }}</h3>
                    <div :class="[statusForm ? 'blocker' : '']">
                        <div class="verify-form__document passport_file" @click="$refs.passport.click()">
                            <div
                                class="verify-form__document-img passport"
                                :class="[scan.passport_file ? 'img-activated' : '']"
                                ref="passport_file"
                                data-vv-name="SCAN_PASSPORT"
                                v-model="scan.passport_file"
                                v-validate="'required'"
                            >
                            </div>
                            <div class="verify-form__document-text">
                                <h3>{{ $t('profile.scan.passport-data') }}</h3>
                                <div class="verify-form__document-link">
                                    <input
                                        type="file"
                                        id="passport_file"
                                        ref="passport"
                                        @change="imgIsLoad"
                                    >
                                    <span v-if="!scan.passport_file">{{ $t('profile.scan.selected') }}</span>
                                    <div
                                        class="verify-form__document-desc"
                                        :style="[scan.passport_file ? {'margin-bottom': '5px'} : {'margin-top': '5px'}]"
                                    >
                                        {{scan.passport_file ? scan.passport_file.name : $t('profile.scan.size')}}
                                    </div>
                                    <span v-if="scan.passport_file">{{ $t('profile.scan.change-file') }}</span>
                                </div>
                            </div>
                        </div>

                        <div class="error-text">
                            {{errors.first('SCAN_PASSPORT')}}
                        </div>

                        <div
                            class="verify-form__document passport_visa"
                            @click="$refs.registration.click()"
                        >
                            <div
                                class="verify-form__document-img registration"
                                :class="[scan.passport_visa ? 'img-activated' : '']"
                                ref="passport_visa"
                                data-vv-name="SCAN_REGISTRATION"
                                v-model="scan.passport_visa"
                                v-validate="'required'"
                            />
                            <div class="verify-form__document-text">
                                <h3>{{ $t('profile.scan.registration') }}</h3>
                                <div class="verify-form__document-link">
                                    <input
                                        type="file"
                                        id="passport_visa"
                                        ref="registration"
                                        @change="imgIsLoad"
                                    >
                                    <span v-if="!scan.passport_visa">{{ $t('profile.scan.selected') }}</span>
                                    <div
                                        class="verify-form__document-desc"
                                        :style="[scan.passport_visa ? {'margin-bottom': '5px'} : {'margin-top': '5px'}]"
                                    >
                                        {{scan.passport_visa ? scan.passport_visa.name : $t('profile.scan.size')}}
                                    </div>
                                    <span v-if="scan.passport_visa">{{ $t('profile.scan.change-file') }}</span>
                                </div>
                            </div>
                        </div>

                        <div class="error-text">
                            {{errors.first('SCAN_REGISTRATION')}}
                        </div>
                    </div>

                </div>
            </base-container>

            <base-container size="small">
                <div class="grouped-buttons" v-if="!block">
                    <base-button
                         :disabled="statusForm"
                         :text="$t('button.clear')"
                         size="80px"
                         theme="clear"
                         @click="clearForm" />

                    <div class="flex">
                        <base-button
                             :disabled="statusForm"
                             :text="$t('button.skip')"
                             class="btn-orange btn-primary--min-width"
                             style="margin-right: 10px"
                             @click="$router.push('/ois')"
                        />

                        <base-button
                             :disabled="statusForm"
                             :text="$t('button.save')"
                             class="btn-primary--min-width"
                             @click="saveProfile"
                        />
                    </div>
                </div>
                <div class="grouped-buttons float-right" v-else>
                    <base-button
                         :disabled="statusForm"
                         :text="$t('button.inMain')"
                         class="btn-orange btn-primary--min-width"
                         @click="$router.push('/ois')"
                    />
                </div>
            </base-container>
        </form>
    </base-detail-page>
</template>

<script>
import pdf from '@/assets/img/icons/pdf.svg/';
import TextStatus from '@/components/TextStatus/';
import { mapGetters } from 'vuex';
import dayjs from 'dayjs';

import inputs from 'mixins/inputs';

const formDataFile = new FormData();

export default {
    name: 'app-profile',
    mixins: [ inputs ],
    components: {
        TextStatus
    },
    data() {
        return {
            astatusForm: false,
            profile: {
                surname: '',
                name: '',
                patronymic: '',
                birthday: '',
                phone: '',
                passport_num: '',
                passport_date: '',
                passport_issued_by: '',
                passport_department: '',
                address: ''
            },
            scan: {
                passport_file: '', // Копия паспорта, разворот с паспортными данными
                passport_visa: '' // Копия паспорта, разворот с пропиской
            },
            block: false
        }
    },
    computed: {
        percent() {
            const profilePercent = Object.values(this.profile).filter((key) => key.length > 1).length,
                scanPercent = Object.values(this.scan).filter((key) => key.length !== 0).length;

            return profilePercent * 9 + scanPercent * 5;
        },
        ...mapGetters('stateForm', ['statusForm'])
    },
    created() {
        this.$http.get('https://id.test.ipex.global/api/profile')
            .then(({ data }) => {
                console.log('created: ', data)
                Object.keys(this.profile).forEach((key) => {
                    this.profile[key] = data[key];
                    this.profile['birthday'] = dayjs(data['birthday']).format('DD.MM.YYYY') || '';
                    this.profile['passport_date'] = dayjs(data['passport_date']).format('DD.MM.YYYY') || '';
                });
            });
    },
    mounted() {
        Object.keys(this.profile).forEach((key) => {
            if (this.profile[key].length) {
                this.$store.dispatch('stateForm/changeStatusForm');
                this.block = true;
            }
        });
    },
    methods: {
        imgIsLoad(el) {
            let id = el.target.id;
            let file = el.target.files[0];

            if (['image/jpeg', 'image/png', 'image/tiff', 'application/pdf'].includes(file.type)) {
                if (file.size < 40000000) {
                    this.scan[id] = file;

                    let reader = new FileReader();

                    reader.onload = (e) => {
                        this.$refs[id].style.backgroundImage = file.type === 'application/pdf' ? 'url(' + pdf + ')' : 'url(' + e.target.result + ')';
                        this.$refs[id].style.backgroundSize = file.type === 'application/pdf' ? '70px 60px' : 'cover';
                    };
                    reader.readAsDataURL(file);
                } else {
                    alert('Размер файла слишком большой!');
                }
            } else {
                alert('За...а! Формат не читается!');
            }
        },
        clearForm() {
            Object.keys(this.profile).forEach(k => this.profile[k] = '');
            Object.keys(this.scan).forEach(k => {
                this.scan[k] = '';
                this.$refs[k].removeAttribute('style');
            });
        },
        getNameFile(name) {
            formDataFile.delete('name');

            return new Promise((resolve) => {
                formDataFile.append('name', name);
                this.$http.post('https://id.test.ipex.global/api/v1/files/drop-files', formDataFile).then(() => resolve());
            });
        },
        uploadFile(name) {
            formDataFile.delete('field_name');
            formDataFile.delete('file');

            return new Promise((resolve) => {
                formDataFile.append('field_name', name);
                formDataFile.append('file', this.scan[name]);
                this.$http.post('https://id.test.ipex.global/api/v1/files/upload', formDataFile).then(() => resolve());
            })
        },
        saveProfile() {
            this.$validator.validateAll()
                .then((valid) => {
                    if (valid) {
                        this.$store.dispatch('stateForm/changeStatusForm');
                        formDataFile.append('_token', this.$store.state.account.token);
                        Promise.all([this.getNameFile('passport_file'), this.getNameFile('passport_visa') ])
                            .then(() => {
                                formDataFile.delete('name');
                                Promise.all([this.uploadFile('passport_file'), this.uploadFile('passport_visa')])
                                    .then(() => {
                                        formDataFile.delete('field_name');
                                        formDataFile.delete('file');
                                        formDataFile.delete('name');
                                        for (let key in this.profile) {
                                            formDataFile.append(key, this.profile[key]);
                                        }
                                        axios.post('https://id.test.ipex.global/api/profile/person/store', formDataFile, this.$http.requests.post)
                                            .then(() => this.block = true)
                                            .catch((err) => {
                                                console.log('Error from profile/person/store', err.response);
                                                this.$store.dispatch('stateForm/changeStatusForm');
                                            });
                                    })
                                    .catch((err) => {
                                        console.log('Ошибка ручки api/v1/files/upload', err);
                                        this.$store.dispatch('stateForm/changeStatusForm');
                                    });
                            })
                            .catch((err) => {
                                console.log('Ошибка при получение ручки drop-file', err);
                                this.$store.dispatch('stateForm/changeStatusForm');
                            });
                    } else {
                        let err = this.$validator.errors.items[0].field;
                        this.$refs[err].focus();
                    }
                });
        }
    }
};
</script>
